%{expand: %%define _includedir	%{_includedir}/%{name}}

Summary:	A collection of SNMP protocol tools and libraries.
Name:		net-snmp
Version:	5.1
Release:	1.5.2
License:	BSDish
Group:		System Environment/Daemons
Source0:	ftp://net-snmp.sourceforge.net/net-snmp-%{version}.tar.gz
Patch01:	ucd-snmp-4.2.4.pre3-mnttab.patch
Patch02:	net-snmp-5.0.1-initializer.patch
Patch03:	net-snmp-5.0.6-syslog.patch
Patch04:	net-snmp-5.0.6-compat.patch
Patch05:	net-snmp-5.0.6-libtool.patch
Patch06:	net-snmp-5.0.8-ipv6-sock-close.patch
Patch07:	net-snmp-5.0.8-readonly.patch
Patch08:	net-snmp-5.1-libwrap.patch
Patch09:	net-snmp-5.1-sensors.patch
Patch10:	net-snmp-5.1-getopt.patch
Patch11:	net-snmp-5.1-xs-label-iid.patch
Patch12:	net-snmp-5.1-async-getnext.patch
Patch13:	net-snmp-5.1-hr_storage-mbuf-v2.patch
Patch20:	net-snmp-5.1-engardeize-gd-1.diff
Prereq:		/sbin/chkconfig
Obsoletes:	ucd-snmp
BuildRoot:	%{_tmppath}/%{name}-%{release}-root
BuildPrereq:	openssl-devel, bzip2-devel, lm_sensors-devel, tcp_wrappers

%description
SNMP (Simple Network Management Protocol) is a protocol used for
network management. The NET-SNMP project includes various SNMP tools:
an extensible agent, an SNMP library, tools for requesting or setting
information from SNMP agents, tools for generating and handling SNMP
traps, a version of the netstat command which uses SNMP, and a Tk/Perl
mib browser. This package contains the snmpd and snmptrapd daemons,
documentation, etc.

%files
  %defattr(-,root,root,-)
  %doc AGENT.txt COPYING ChangeLog EXAMPLE.conf FAQ NEWS PORTING README* TODO
  %doc local/passtest local/README.mib2c local/ipf-mod.pl
  %attr(0444,root,root)	%doc %{_mandir}/man[58]/*

  %dir %{_sysconfdir}/snmp
  %attr(0640,root,admin)	%config(noreplace,missingok) %{_sysconfdir}/snmp/snmpd.conf
  %attr(0700,root,root)		%config(noreplace) %{_sysconfdir}/init.d/snmpd
  %attr(0700,root,root)		%config(noreplace) %{_sysconfdir}/init.d/snmptrapd
  %attr(0600,root,root)		%config(noreplace) %{_sysconfdir}/logrotate.d/snmpd

  %attr(0511,root,root)		%{_bindir}/ucd5820stat
  %attr(0555,root,root)		%{_libdir}/lib*.so.*
  %attr(0500,root,root)		%{_sbindir}/snmpd
  %attr(0500,root,root)		%{_sbindir}/snmptrapd

# XXX
%{_datadir}/snmp

%package utils
Group:		Applications/System
Summary:	Network management utilities using SNMP, from the NET-SNMP project.
Requires:	net-snmp = %{version}
Obsoletes:	ucd-snmp-utils

%description utils
The net-snmp-utils package contains various utilities for use with the
NET-SNMP network management project.

%files utils
  %defattr(-,root,root,-)
  %attr(0444,root,root)	%doc %{_mandir}/man1/*

  %attr(0555,root,root)		%{_bindir}/fixproc
  %attr(0555,root,root)		%{_bindir}/ipf-mod.pl
  %attr(0555,root,root)		%{_bindir}/encode_keychange
  %attr(0555,root,root)		%{_bindir}/snmpbulkget
  %attr(0555,root,root)		%{_bindir}/snmpbulkwalk
  %attr(0555,root,root)		%{_bindir}/snmpconf
  %attr(0555,root,root)		%{_bindir}/snmpdelta
  %attr(0555,root,root)		%{_bindir}/snmpdf
  %attr(0555,root,root)		%{_bindir}/snmpget
  %attr(0555,root,root)		%{_bindir}/snmpgetnext
  %attr(0555,root,root)		%{_bindir}/snmpinform
  %attr(0555,root,root)		%{_bindir}/snmpnetstat
  %attr(0555,root,root)		%{_bindir}/snmpset
  %attr(0555,root,root)		%{_bindir}/snmpstatus
  %attr(0555,root,root)		%{_bindir}/snmptable
  %attr(0555,root,root)		%{_bindir}/snmptest
  %attr(0555,root,root)		%{_bindir}/snmptranslate
  %attr(0555,root,root)		%{_bindir}/snmptrap
  %attr(0555,root,root)		%{_bindir}/snmpusm
  %attr(0555,root,root)		%{_bindir}/snmpwalk
  %attr(0555,root,root)		%{_bindir}/snmpvacm
  %attr(0555,root,root)		%{_bindir}/traptoemail

%package devel
Group:		Development/Libraries
Summary:	The development environment for the NET-SNMP project.
Requires:	net-snmp = %{version}
Obsoletes:	ucd-snmp-devel

%description devel
The net-snmp-devel package contains the development libraries and
header files for use with the NET-SNMP project's network management
tools.

%files devel
  %defattr(0444,root,root,0555)

  %attr(0444,root,root)		%doc %{_mandir}/man3/*.3.*
  %attr(0555,root,root)		%{_libdir}/*.so
  %attr(0444,root,root)		%{_libdir}/*.a
  %attr(0444,root,root)		%{_libdir}/*.la
  %attr(0555,root,root)		%{_bindir}/net-snmp-config

  %attr(0444,root,root)		%{_prefix}/include/net-snmp/*.h
  %attr(0444,root,root)		%{_prefix}/include/net-snmp/*/*.h
  %attr(0444,root,root)		%{_prefix}/include/ucd-snmp/*.h

%package perl
Group:		Development/Libraries
Summary:	The perl NET-SNMP module and the mib2c tool.
Requires:	net-snmp = %{version}, perl >= 5
BuildRequires:	perl >= 5

%description perl
The net-snmp-perl package contains the perl files to use SNMP from within
Perl.

%files perl -f perl.lst
  %defattr(-,root,root)

  %attr(0555,root,root)	%{_bindir}/mib2c
  %attr(0444,root,root)	%doc %{_mandir}/man1/mib2c.1*
  %attr(0444,root,root)	%doc %{_mandir}/man3/*.3pm.*

%prep
%setup -q
%patch01 -p1
%patch02 -p1
%patch03 -p1
%patch04 -p1
%patch05 -p1
%patch06 -p1
%patch07 -p1
%patch08 -p1
%patch09 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch20 -p1

  # Do this patch with a perl hack...
  perl -pi -e "s|'\\\$install_libdir'|'%{_libdir}'|" ltmain.sh

%build
%ifarch ia64 x86_64 s390x ppc64
export LDFLAGS="-L%{_libdir}"
%endif

  %configure \
	--enable-static 				\
	--enable-shared					\
	--with-cflags="$RPM_OPT_FLAGS"			\
	--with-sys-location="Unknown"			\
	--with-logfile="/var/log/snmpd.log"		\
	--with-persistent-directory="/var/net-snmp"	\
	--with-mib-modules="host agentx smux"		\
	--with-libwrap=%{_libdir}			\
	--sysconfdir=%{_sysconfdir}			\
	--enable-ipv6					\
	--enable-ucd-snmp-compatibility			\
	--with-pic					\
	--with-sys-contact="root@localhost" <<EOF


EOF

  make

  pushd perl
    OPTIMIZE="$RPM_OPT_FLAGS" perl Makefile.PL -NET-SNMP-IN-SOURCE=true PREFIX=${RPM_BUILD_ROOT}/%{_prefix}
    make
  popd

%install
  [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

  %makeinstall  ucdincludedir=${RPM_BUILD_ROOT}/usr/include/ucd-snmp

  mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/snmp
  mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/init.d
  mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/logrotate.d
  mkdir -p $RPM_BUILD_ROOT/%{_bindir}

  pushd engarde
    install net-snmp.engarde.conf $RPM_BUILD_ROOT/%{_sysconfdir}/snmp/snmpd.conf
    install net-snmpd.init        $RPM_BUILD_ROOT/%{_sysconfdir}/init.d/snmpd
    install net-snmptrapd.init    $RPM_BUILD_ROOT/%{_sysconfdir}/init.d/snmptrapd
    install net-snmpd.logrotate   $RPM_BUILD_ROOT/%{_sysconfdir}/logrotate.d/snmpd
    install ucd5820stat           $RPM_BUILD_ROOT/%{_bindir}/ucd5820stat
  popd

  rm -f $RPM_BUILD_ROOT/%{_bindir}/snmpinform
  rm -f $RPM_BUILD_ROOT/%{_bindir}/tkmib
  rm -f $RPM_BUILD_ROOT/%{_bindir}/snmpcheck
  rm -f $RPM_BUILD_ROOT/%{_mandir}/man1/snmpconf.1*
  ln -s snmptrap $RPM_BUILD_ROOT/%{_bindir}/snmpinform

  # copy missing mib2c.conf files
  cp local/mib2c.*.conf $RPM_BUILD_ROOT/%{_datadir}/snmp

  pushd perl
    eval $(perl '-V:installsitelib')

    make PREFIX=$RPM_BUILD_ROOT/%{_prefix} \
	 INSTALLMAN1DIR=$RPM_BUILD_ROOT/%{_mandir}/man1 \
	 INSTALLMAN3DIR=$RPM_BUILD_ROOT/%{_mandir}/man3 install

    gzip -9 $RPM_BUILD_ROOT/%{_mandir}/man3/*.* || :
    gzip -9 $RPM_BUILD_ROOT/%{_mandir}/man1/*.* || :

    find $RPM_BUILD_ROOT/%{_libdir} -name Makefile.subs.pl | xargs rm -f
    find $RPM_BUILD_ROOT/%{_libdir} -name perllocal.pod | xargs rm -f
    find $RPM_BUILD_ROOT/%{_libdir} -name .packlist | xargs rm -f

    find $RPM_BUILD_ROOT/$installsitelib -type f -print \
        -o -type d -a \
        -name NetSNMP -printf '%%%%dir %%p\n' \
        -o -name SNMP -printf '%%%%dir %%p\n' | \
        sed "s@$RPM_BUILD_ROOT@@g" > ../perl.lst
  popd

  find $RPM_BUILD_ROOT -name '*.so' | xargs chmod 0755

%post
  /sbin/ldconfig

%preun
  if [ $1 = 0 ]; then
    /etc/init.d/snmpd stop     > /dev/null 2>&1 || :
    /etc/init.d/snmptrapd stop > /dev/null 2>&1 || :

    /sbin/chkconfig --del snmpd
    /sbin/chkconfig --del snmptrapd

    # remove stale autogenerated file
    rm -f %{_datadir}/snmp/mibs/.index
  fi

%postun
  /sbin/ldconfig

  if [ "$1" -ge "1" ]; then
    /etc/init.d/snmpd     condrestart >/dev/null 2>&1 || :
    /etc/init.d/snmptrapd condrestart >/dev/null 2>&1 || :
  fi

%clean
  [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%changelog
* Thu Feb 05 2004 Ryan W. Maple <ryan@guardiandigital.com>
- Version 5.1, Release 1.5.2
  - EnGarde-ize initscripts, etc.

* Fri Jan 30 2004 Ryan W. Maple <ryan@guardiandigital.com>
- Version 5.1, Release 1.5.1
  - Initial build for EnGarde, initial SRPM taken from Fedora.
